var config = require('./Config');
var _ = require('lodash');
var apn = require('apn');

var push = function (tokens, payload, errorHandle, feedback) {
    apnSender(errorHandle, feedback).pushNotification(payload, tokens);
};

var buildPayload = function (options) {
    var notif = new apn.Notification(options.payload);

    notif.expiry = options.expiry || 0;
    notif.alert = options.alert;
    notif.badge = options.badge;
    notif.sound = options.sound;

    return notif;
};

var apnSender = _.once(function (errorHandle, feedback) {
    var apnConnection = new apn.Connection(config.get('apn').connection);

    apnConnection.on('transmissionError', errorHandle);
    initAppFeedback(feedback);

    return apnConnection;
});

var initAppFeedback = function (feedback) {
    var apnFeedback = new apn.Feedback(config.get('apn').feedback)

    apnFeedback.on('feedback', feedback);
};

module.exports = {
    push: push,
    buildPayload: buildPayload
}