var config = require('./Config')
var _ = require('lodash');
var gcm = require('node-gcm');

var push = function (tokens, message, done) {
    gcmSender().send(message, tokens, 4, function (err, res) {
        if(err) console.log(err);

        if (res && res.failure > 0) {
            var mappedResults = _.map(_.zip(tokens, res.results), function (arr) {
                return _.merge({token: arr[0]}, arr[1]);
            });

            handleResults(mappedResults, done);
        }
    })
};

var handleResults = function (results, done) {
    var idsToUpdate = [],
        idsToDelete = [];

    results.forEach(function (result) {
        if (!!result.registration_id) {
            idsToUpdate.push({from: result.token, to: result.registration_id});

        } else if (result.error === 'InvalidRegistration' || result.error === 'NotRegistered') {
            idsToDelete.push(result.token);
        }
    });

    done(idsToUpdate, idsToDelete);
};

var buildPayload = function (options) {
    return new gcm.Message(options);
};

var gcmSender = _.once(function() {
    return new gcm.Sender(config.get('gcm').apiKey);
});

module.exports = {
    push: push,
    buildPayload:buildPayload
}