var _ = require('lodash'),
    apnPusher = require('./APNPusher'),
    gcmPusher = require('./GCMPusher'),
    config = require('./Config');

var Service = function () {
    
};

Service.init = function (configFilePath) {
    config.initialize(configFilePath);
};


Service.send = function (pushAssociations, androidPayload, iosPayload, errorHandle, feedback, done) {
    var androidTokens = _(pushAssociations).where({deviceOS: 'android'}).map('deviceToken').value();
    var iosTokens = _(pushAssociations).where({deviceOS: 'ios'}).map('deviceToken').value();

    if (androidPayload && androidTokens.length > 0) {
        var gcmPayload = gcmPusher.buildPayload(androidPayload);
        gcmPusher.push(androidTokens, gcmPayload, function(idsToUpdate, idsToDelete) {
            done(idsToUpdate, idsToDelete);
        });
    }

    if (iosPayload && iosTokens.length > 0) {
        var apnPayload = apnPusher.buildPayload(iosPayload);
        apnPusher.push(iosTokens, apnPayload, errorHandle, feedback);
    }
};

module.exports = Service;